//------------------------------------------------------------------
#property copyright   "copyright mladen"
#property description "recursive moving trendline"
#property description "made for metatrader by mladen"
#property description "for more visit www.forex-tsd.com"
#property link        "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers    3
#property indicator_color1     LimeGreen
#property indicator_color2     Orange
#property indicator_color3     Orange
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2

extern int                RmtaPeriod = 21;
extern ENUM_APPLIED_PRICE RmtaPrice  = PRICE_MEDIAN;

double rmta[];
double rmtada[];
double rmtadb[];
double bot[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,rmta);
   SetIndexBuffer(1,rmtada);
   SetIndexBuffer(2,rmtadb);
   SetIndexBuffer(3,bot);
   SetIndexBuffer(4,slope);
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--; 
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   double alpha = 2.0/(RmtaPeriod+1);
   if (slope[limit]==-1) CleanPoint(limit,rmtada,rmtadb);
   for(int i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,RmtaPrice,i);
      bot[i]  = price;
      rmta[i] = price;
         if (i<Bars-1)
         {
            bot[i]  = (1-alpha)*bot[i+1]+price;
            rmta[i] = (1-alpha)*rmta[i+1]+alpha*(price+bot[i]-bot[i+1]);
         }            
         rmtada[i] = EMPTY_VALUE;
         rmtadb[i] = EMPTY_VALUE;
         slope[i]  = slope[i+1];
            if (rmta[i]>rmta[i+1]) slope[i] =  1;
            if (rmta[i]<rmta[i+1]) slope[i] = -1;
            if (slope[i]==-1) PlotPoint(i,rmtada,rmtadb,rmta);
               
   }
   return(0); 
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>Bars-2) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>Bars-3) return;
   if (first[i+1] == EMPTY_VALUE)
         if (first[i+2] == EMPTY_VALUE) 
               { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
         else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else        { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}